function g=gaussian_blob(H, W, mu_y, mu_x, sigma)
% creates a gaussian blob with centeer (my_x, mu_y) and covariance sigma
%
% author jlezama@fing.edu.uy

sigmainv = inv(sigma);

g=zeros([H W]);

[X, Y] = meshgrid([1:W], [1:H]);


mu_x = ones(H*W,1)*mu_x;
mu_y = ones(H*W,1)*mu_y;


 d = sum(-1/2*(([X(:)-mu_x(:) Y(:)-mu_y(:)])*...
     sigmainv).*([X(:)-mu_x(:) Y(:)-mu_y(:)]),2);
 
 % d = diag(d);
        
 g = 1/(2*pi*sqrt(det(sigma)))*exp(d);

 g = normalize(reshape(g, [H W])); 