%% Guide generator Version 4 - level set method
function [] = guide_generator_main(output1,blob1,blob2,output2,output3,output4,...
    r_txt,W_txt,sig_disp_txt,max_disp_x_txt,max_disp_y_txt,...
    blob_vert_pos1_txt,blob_vert_pos2_txt,blob_hor_pos1_txt,...
    blob_hor_pos2_txt,num_int_txt,blob_mult1_txt, blob_mult2_txt,...
    surf_decay_txt, rho1_txt,E1_txt,sig1_txt,...
    rho2_txt,E2_txt,sig2_txt,rnd_wgt_txt)

%% set random seed
% rng('shuffle')% forces the demo to change the seed for random generation
%% set fix seed
rng(0)

%% get parameters
% set dimensions of the plank
r = str2double(r_txt);
W = str2double(W_txt);

% set parameters for guides g1 and g2
sigma_disp = str2double(sig_disp_txt); 
max_disp_x = str2double(max_disp_x_txt);
max_disp_y = str2double(max_disp_y_txt);
blob_vert_pos =  [str2double(blob_vert_pos1_txt) str2double(blob_vert_pos2_txt)];
blob_hor_pos = [str2double(blob_hor_pos1_txt) str2double(blob_hor_pos2_txt)];
num_int = str2double(num_int_txt);
blob_mult = [str2double(blob_mult1_txt) str2double(blob_mult2_txt)];
surf_decay = str2double(surf_decay_txt);
rho1 = str2double(rho1_txt);
E1 = str2double(E1_txt);
sig1 = str2double(sig1_txt);
rho2 = str2double(rho2_txt);
E2 = str2double(E2_txt);
sig2 = str2double(sig2_txt);
rnd_wgt = str2double(rnd_wgt_txt);

params = [r W sigma_disp max_disp_x max_disp_y blob_vert_pos ...
    blob_hor_pos num_int blob_mult surf_decay...
    rho1 E1 sig1 rho2 E2 sig2 rnd_wgt];

%% generate guide
% s1 : initial surface
% g1 : gaussian blob 1
% g2 : gaussian blob 2
% s3 : surface with blobs and random deformation
% s4 : contour lines
[s1,g1,g2,s2,s3,s4] = guide_generator(params);

%% save results
% save image s1
% create indexed image, explicitly using 256 colors
imInd=gray2ind(s1,256);
% convert indexed image to RGB using 256-colors jet map
jetRGB=ind2rgb(imInd,jet(256));
imwrite(jetRGB,output1);
% save image g1
imInd=gray2ind(blob_mult(1)*g1,256);
jetRGB=ind2rgb(imInd,jet(256));
imwrite(jetRGB,blob1);
% save image g2
imInd=gray2ind(g2,256);
jetRGB=ind2rgb(imInd,jet(256));
imwrite(jetRGB,blob2);
% save image s2
imInd=gray2ind(s2,256);
jetRGB=ind2rgb(imInd,jet(256));
imwrite(jetRGB, output2);
% save image s3
imInd=gray2ind(s3,256);
jetRGB=ind2rgb(imInd,jet(256));
imwrite(jetRGB, output3);
% save image s4
imwrite(s4, output4);